%if 0%{?fc7}
%else
  %define _remove_encoding --remove-key Encoding
%endif

Summary:	UML2 tool box for C++, Java, IDL, PHP and Python
Name:		bouml
Version:	4.12.1
Release:	1%{?dist}
License:	GPLv2+
Group:		Development/Tools
URL:		http://bouml.free.fr/
Source0:	http://downloads.sourceforge.net/bouml/%{name}_%{version}.tar.gz

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Requires:	hicolor-icon-theme

BuildRequires:	desktop-file-utils

%if 0%{?fc7}%{?fc8}
BuildRequires:	qt-devel
%else
BuildRequires:	qt3-devel
%endif

%description
BOUML is a Unified Modeling Language editor for Qt. You can use it to create
nearly all of UML diagrams. BOUML can generate code from those diagrams in
C++, Java, IDL, PHP and Python, and can also reverse existing code.

The program supports class diagrams, sequence diagrams, collaboration
diagrams, object diagrams, use case diagrams, component diagrams, state
diagrams, activity diagrams, component diagrams and deployment diagrams.

The documentation for this package is in %{name}-doc.

%prep
%setup -q -n %{name}_%{version}

%build
# To prevent failure on ppc64 and x86_64.
make %{?_smp_mflags} BOUML_LIB=%{_libdir}/%{name}

%install
rm -rf $RPM_BUILD_ROOT

# To prevent failure on ppc64 and x86_64.
make install BOUML_LIB=%{_libdir}/%{name} DESTDIR=$RPM_BUILD_ROOT

# Symlinks need to be relative.
pushd $RPM_BUILD_ROOT%{_bindir}
  unlink projectControl
  unlink projectSynchro
  ln -s ../%{_lib}/%{name}/projectControl projectControl
  ln -s ../%{_lib}/%{name}/projectSynchro projectSynchro
popd

desktop-file-install %{?_remove_encoding} --vendor fedora --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop

desktop-file-install %{?_remove_encoding} --vendor fedora --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/projectControl.desktop

desktop-file-install %{?_remove_encoding} --vendor fedora --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/projectSynchro.desktop

%clean
rm -rf $RPM_BUILD_ROOT

%post
touch --no-create %{_datadir}/icons/hicolor || :
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
touch --no-create %{_datadir}/icons/hicolor || :
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%files
%defattr(-,root,root,-)
%doc historic.html
%doc licence.txt
%{_bindir}/%{name}
%{_bindir}/projectControl
%{_bindir}/projectSynchro
%{_datadir}/applications/fedora-%{name}.desktop
%{_datadir}/applications/fedora-projectControl.desktop
%{_datadir}/applications/fedora-projectSynchro.desktop
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/16x16/apps/projectControl.png
%{_datadir}/icons/hicolor/16x16/apps/projectSynchro.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/projectControl.png
%{_datadir}/icons/hicolor/32x32/apps/projectSynchro.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/projectControl.png
%{_datadir}/icons/hicolor/48x48/apps/projectSynchro.png
%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
%{_datadir}/icons/hicolor/64x64/apps/projectControl.png
%{_datadir}/icons/hicolor/64x64/apps/projectSynchro.png

%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*

%changelog
* Wed Apr 08 2009 Debarshi Ray <rishi@fedoraproject.org> - 4.12.1-1
- Version bump to 4.12.1.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * Python Generator:
    + When a class referenced another one placed in the same python package,
      the python code generator wrongly produced <artifact name>.<class name>
      rather than <package name>.<artifact name>.<class name>. Fixed.
  * XMI2 Generator:
    + When an association is defined between a class and an actor, an
      unexpected and inconsistent attribute was generated. Fixed. 
  * When a class associated with a relation (for instance in case of a class
    relation) is deleted, the plug-out API operation
    UmlRelation::association() wrongly returned the deleted class. Fixed.
  * In a diagram when two elements were linked by a line (whatever it
    represented) and one of the elements contained the other one, the line was
    not drawn. This was mainly a problem in case of high-level transition from
    a composite state with a target inside the composite state. Fixed.
  * Changing the geometry of a junction between two instances in a
    communication diagram, without supporting a message, using the menu,
    produced a crash. Fixed.
  * Duplicating an activity might produce a crash. Fixed.
  * When any colour is assigned to an activity partition in horizontal display
    mode, closing and re-opening the diagram produced an error message and a
    part of the diagram was lost. Fixed.
  * In a state diagram it was possible to resize choices by selecting them
    with other elements and doing a resize. Ditto for decision and merge in an
    activity diagram. Fixed.
  * The virtual desktop set through the environment dialog was not taken into
    account. Fixed.
  * Added new US diagram formats: letter, legal, tabloid, letter landscape,
    legal landscape and ledger.
  * It is now possible to add marked elements in class, use case, component
    and deployment diagrams though the diagram menu entry add marked elements.
  * It is now possible to add related elements in diagram for a class, use
    case, package, component, artifact and deployment node. A related element
    is an element having a relation with the current element which can be
    shown in the current diagram and part of the browser.
  * http://bouml.free.fr/historic.html
- glibc-2.10 fixes accepted by upstream.

* Mon Feb 23 2009 Release Engineering <rel-eng@fedoraproject.org> - 4.11-2
- Autorebuild for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Feb 17 2009 Debarshi Ray <rishi@fedoraproject.org> - 4.11-1
- Version bump to 4.11.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * XMI2 Import and XMI2 Generator:
    + Forms produced / expected for provided and required interfaces and for
      realizing classes were not the right ones. Fixed.
    + Importing of forms produced by previous releases is not managed.
  * A crash might occur when the drawing setting is changed depending on the
    changes made before. Fixed.
  * In an activity, when an element was created through an activity diagram
    placing the element directly on a partition, this element was wrongly
    nested in the partition in the browser, and it was impossible to reload
    the project. Fixed.
  * The modeler entered in an infinite loop when it is attempted to change the
    geometry of an extension (uni directional association from a
    stereotype-class to a meta class). Fixed.
  * When a class present in at least two of the provided required and
    realizing lists of a component was deleted, and the model was saved and
    reloaded, the model became inconsistent and a crash could occur. Fixed.
  * Validating the edition of a relation whose first role is read only and
    without property (tagged value) produced a crash. Fixed.
  * http://bouml.free.fr/historic.html
- Fixed build failure with glibc-2.10.

* Sat Nov 22 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.8.3-1
- Version bump to 4.8.3. (Red Hat Bugzilla #472408)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * Modification of some generation settings through a plug-out could produce a
    crash. Fixed. Plug-outs need to be fixed with plug-out upgrade.
  * A crash occured when only one language was selected and the parameters list
    of an operation defined for an actor placed in a use case or a use case
    view was modified. Fixed. 
  * Plug-outs need to be modified to use the meta classes and extensions
    rather than the properties stereotypeExtension on the stereotypes.
  * http://bouml.free.fr/historic.html
- Shortened summary to suit PackageKit's UI.

* Sat Sep 06 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.5-1
- Version bump to 4.5. (Red Hat Bugzilla #460528)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * Loading a project containing a modelled class instance (part of the
    browser) having a deleted (in a previous session) modelled class instance
    as a relation value instance might cause a crash. Fixed.
  * Loading a project containing modelled class instances (part of the
    browser) specifying values for relations might cause a crash. Fixed. 
  * http://bouml.free.fr/historic.html

* Sun Jun 15 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.3.5-1
- Version bump to 4.3.5. (Red Hat Bugzilla #448520)
  * http://bouml.free.fr/historic.html

* Wed May 14 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.3.3-1
- Version bump to 4.3.3. (Red Hat Bugzilla #445908)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * Plug-out:
    + In class UmlBasePackage, the operations findNamespace, findPackage and
      findModule have been renamed to findCppNamespace, findJavaPackage and
      findIdlModule. Modify your plug-outs to use the new names.
  * http://bouml.free.fr/historic.html

* Sun Apr 06 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.2-2
- Replaced 'BuildRequires: qt-devel' with 'Buildrequires: qt3-devel' on all
  distributions starting from Fedora 9. (Red Hat Bugzilla #440750)

* Fri Feb 22 2008 Debarshi Ray <rishi@fedoraproject.org> - 4.2-1
- Version bump to 4.2. (Red Hat Bugzilla #434284)
  * Introduced Python support.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * A class can now be drawn as a class (without members), or using boundary,
    control or entity icon in a use case diagram.
  * The name of use case is not anymore a separated label and the size of an
    actor now depends on its name, so, the position of the incoming and
    outgoing arrows and the position of the name will be impacted.  
  * http://bouml.free.fr/historic.html

* Tue Feb 19 2008 Release Engineering <rel-eng@fedoraproject.org> - 3.5-2
- Autorebuild for gcc-4.3.

* Wed Jan 16 2008 Debarshi Ray <rishi@fedoraproject.org> - 3.5-1
- Version bump to 3.5. (Red Hat Bugzilla #428840)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic.html

* Fri Dec 21 2007 Debarshi Ray <rishi@fedoraproject.org> - 3.4-1
- Version bump to 3.4. (Red Hat Bugzilla #426485)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic.html

* Thu Nov 29 2007 Debarshi Ray <rishi@fedoraproject.org> - 3.3.3-1
- Version bump to 3.3.3. (Red Hat Bugzilla #398811)
  * http://bouml.free.fr/historic.html
- Fixed usage of _remove_encoding to prevent failure on Fedora 7.

* Sun Nov 25 2007 Debarshi Ray <rishi@fedoraproject.org> - 3.3.1-2
- Removed Encoding from Desktop Entry for all distributions, except Fedora 7.

* Tue Nov 13 2007 Debarshi Ray <rishi@fedoraproject.org> - 3.3.1-1
- Version bump to 3.3.1.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic.html
- Removed Encoding from Desktop Entry.

* Sun Nov 04 2007 Debarshi Ray <rishi@fedoraproject.org> - 3.0.2-1
- Version bump to 3.0.2. (Red Hat Bugzilla #326641)
  * Introduced PHP support.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic.html
- Backported bug-fix from 3.3.

* Thu Oct 11 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.32-1
- Version bump to 2.32. (Red Hat Bugzilla #303721)
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic_old.html

* Wed Oct 03 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.31.3-1
- Version bump to 2.31.3. (Red Hat Bugzilla #292541)
  * http://bouml.free.fr/historic_old.html

* Fri Sep 14 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.31.2-1
- Version bump to 2.31.2. (Red Hat Bugzilla bug #286661)
  * http://bouml.free.fr/historic_old.html

* Thu Sep 06 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.31.1-1
- Version bump to 2.31.1.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic_old.html

* Wed Aug 22 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.30.2-1
- Version bump to 2.30.2.
  * http://bouml.free.fr/historic_old.html
- Cleaned up SPEC.

* Sat Aug 04 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.30.1-1
- Version bump to 2.30.1.
  * http://bouml.free.fr/historic_old.html
- Changed value of License according to Fedora licensing guidelines.
- Executable bits turned off for C++ sources by upstream.
- Application removed from Categories by upstream.

* Thu Aug 02 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.30-1
- Version bump to 2.30.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic_old.html
- Removed Application from Categories.

* Sun Jul 29 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.29.1-3
- Fixed build and install stanza to prevent failure on ppc64 and x86_64.
- Added 'Requires: hicolor-icon-theme'.
- Fixed 'gtk-update-icon-cache' in the post[un] scriptlets.
- Removed 'update-desktop-database' from the post[un] scriptlets.

* Fri Jul 27 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.29.1-2
- Modified the summary.
- Replaced lib with _lib.

* Fri Jul 27 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.29.1-1
- Version bump to 2.29.1.
  * http://bouml.free.fr/historic_old.html

* Sun Jul 08 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.29-1
- Version bump to 2.29.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic_old.html

* Wed Jun 29 2007 Debarshi Ray <rishi@fedoraproject.org> - 2.27-1
- Initial build.
  * Previous releases can not read a project saved with this version, but
    projects made by previous releases can be read.
  * http://bouml.free.fr/historic_old.html
